<?php
/*
========================================================
 Plugin Category Parent Style
--------------------------------------------------------
 Author: Oliver Heine
 http://gadgets.silenz.org/
--------------------------------------------------------
 This addon may be used free of charge. Should you
 employ it in a commercial project of a customer or your
 own I'd appreciate a small donation.
========================================================
 File: pi.cat_parent_style.php
--------------------------------------------------------
 Purpose: Applies custom CSS-class to categories that  
          have subcategories
========================================================
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF
 ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT 
 LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO 
 EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
 OR OTHER DEALINGS IN THE SOFTWARE.
=========================================================
*/


$plugin_info = array(
						'pi_name'			=> 'Category Parent Style',
						'pi_version'		=> '1.0',
						'pi_author'			=> 'Oliver Heine',
						'pi_author_url'		=> 'http://gadgets.silenz.org/index.php/gadgets/category/Plugins/',
						'pi_description'	=> 'Applies custom CSS-class to categories that have subcategories using {exp:weblog:categories}',
						'pi_usage'			=> cat_parent_style::usage()
					);


class cat_parent_style {

    var $return_data;
		function apply($str = '')
    {
    	global $TMPL;
    	
    	$class = ( ! $TMPL->fetch_param('class')) ? '' :  $TMPL->fetch_param('class');
    	$TMPL->tagdata = preg_replace("/<li>\s*?{cat_parent}/iU","<li class=\"$class\">",$TMPL->tagdata);
      return $TMPL->tagdata;
  	}
    function check($str = '')
    {
        global $TMPL, $DB;
        
				
     							
     		//category missing -> do nothing
        if ( !$TMPL->fetch_param('cat_id') ) {
            return $TMPL->tagdata;
        } else {

        	  $category = $TMPL->fetch_param('cat_id');
            $result = $DB->query("SELECT cat_id FROM exp_categories WHERE parent_id='$category' LIMIT 1;");
      				if ( $result->num_rows == 1 ) {
      					$TMPL->tagdata = "{cat_parent}".$TMPL->tagdata;
      				} 
      			return $TMPL->tagdata;		
        }
		}
    
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
The Plugin uses two tags. One goes <em>around</em> {exp:weblog:categories}, one goes inside.

The outer one is {exp:cat_parent_style:apply class="myclass"}. It applies class="myclass" to the <li>-tag of any category that has subcategories. You may change "myclass" to any class-name you like.

The inner one is {exp:cat_parent_style:check cat_id="{category_id}"}. It checks whether the current category has subcategories and prepares it for the apply-function.

Example:
---------------------------------------------------------------------
{exp:cat_parent_style:apply class="parent"}
{exp:weblog:categories weblog="default_site" style="nested"}
{exp:cat_parent_style:check cat_id="{category_id}"}

<a href="{path=weblog/index}">{category_name}</a>

{/exp:cat_parent_style:check}
{/exp:weblog:categories}
{/exp:cat_parent_style:apply}
---------------------------------------------------------------------

Result:
---------------------------------------------------------------------
<ul id="nav_categories" class="nav_categories">
  <li class="parent"><a href="#">Our Company</a>
    <ul>
      <li><a href="#">Our Office</a></li>
      <li><a href="#">Our Store</a></li>
      <li class="parent"><a href="#">Our Fleet</a>
        <ul>
          <li><a href="#">Our Planes</a></li>
          <li><a href="#">Our Ships</a></li>
          <li><a href="#">Our Trucks</a></li>
       </ul>
      </li>
    </ul>
  </li>
<li><a href="#">Our Hero</a></li>
<li class="parent"><a href="#">Our Products</a>
  <ul>
    <li class="parent"><a href="#">Air</a>
      <ul>
        <li><a href="#">Lot's of Air</a></li>
        <li><a href="#">More Air</a></li>
        <li><a href="#">Some Air</a></li>
     </ul>
    </li>
    <li class="parent"><a href="#">Water</a>
      <ul>
        <li><a href="#">Blue Water</a></li>
        <li><a href="#">Red Water</a></li>
      </ul>
    </li>
  </ul>
</li>
<li><a href="#">Our Services</a></li>
</ul>
---------------------------------------------------------------------
<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
/* END */


}
// END CLASS
?>
